/* Checktype.c: Sets flag to do check the type of cd before mounting.
   (c) 1997 David A. van Leeuwen

   If you want Linux to say `wrong medium type' when you still have an 
   audio cd in your drive while attempting to mount a cdrom, instead of
   going crazy, run this program. Be sure you have kernel 2.1.27 or higher, 
   and libc-5.4.18 or higher. 
*/

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <linux/ucdrom.h>

main(int ac, char ** av) 
{
  char * device = "/dev/cdrom";
  int fd, dont=0, c;
  int flags;
  FILE * errorfile = stderr;
  extern int optind, optopt;
  while((c=getopt(ac, av, "dh"))!=EOF) {
    switch(c) {
    case 'd': 
      dont=1;
      break;
    case 'h':
      printf("Checktype. Enable checking for audio cdroms during mount.\n"
	     "(c) 1997 David A. van Leeuwen\n\n");
      errorfile=stdout;
    default:
      fprintf(errorfile, "Usage:\n\tchecktype [-d] [device]\n"
	      "\t-d:\tdisable cdrom type checking\n"
	      "\tdevice:\tdefaults to /dev/cdrom\n");
      exit(-1);
    }
  }
  if (ac>optind) device = av[optind];
  fd = open(device, O_RDONLY | O_NONBLOCK);
  if (fd < 0) {
    perror("Can't open device");
    exit(-2);
  }
  if (dont)
    flags=ioctl(fd, CDROM_CLEAR_OPTIONS, CDO_CHECK_TYPE);
  else 
    flags=ioctl(fd, CDROM_SET_OPTIONS, CDO_CHECK_TYPE);
  close(fd);
  if (flags<0) {
    perror("Ioctl error.\n");
    exit(-3);
  }
  printf("Type checking %sabled\n", (flags & CDO_CHECK_TYPE) ? "en" : "dis");
}
